/************************************
Anton (Liloi) Moskalenko
e-mail: liloi@mail.ru
05.08.06
R:
14.08.06
************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>

#include <lca2.h>

using namespace std;

void lca2_help()
{
	cout << "lca [--author/-a][--help/-h][-c/-d,input_fn,output_fn,key]" << endl << endl;
	cout << "\t [--author/-a] \t - show me (it`s meen author) :-)" << endl;
	cout << "\t [--help/-h] \t - show this " << endl;
	cout << "\t [-c] \t\t - crypt (default)" << endl;
	cout << "\t [-d] \t\t - decrypt" << endl;
	cout << endl << "\t [input_fn] \t - name of file to (de)crypt" << endl;
	cout << "\t [output_fn] \t - name of (de)crypted file" << endl;
	cout << "\t [key] \t\t - key (password)" << endl << endl << "Example:" << endl;
	cout << "\t [lca -h -a]" << endl;
	cout << "\t [lca -c input.txt output.lca 12345]" << endl;
	cout << "\t [lca -c input.txt output.txt 12345 -d output.lca input2.txt 12345]" << endl;
	cout << "\t [lca -h -c input.txt output.txt 12345 -h]" << endl;

	cout << endl;
}


void lca2_author()
{
	cout << "Anton (Liloi) Moskalenko" << endl << endl;
	cout << "\te-mail: \t liloi@mail.ru" << endl;
	cout << "\tWeb: \t\t http://liloisproj.narod.ru/" << endl;
	
	cout << endl;
}


int main(int argc, char *argv[])
{

	cout << endl << "LCA" << endl << "Version 2.0 Alpha" << endl
		<< "-=-" << endl << endl;
		
	if(argc==1) cout << "\tType `lca -h` for help" << endl << endl;
        
      
    if(argc>1)
    {
        for(int i = 1;i<argc;i++)
        {
		// commands from the console
            if((strcmp(argv[i],"--author")==0)||(strcmp(argv[i],"-a")==0)) lca2_author(); else
            if((strcmp(argv[i],"--help")==0)||(strcmp(argv[i],"-h")==0)) lca2_help(); else
			if((strcmp(argv[i],"-c")==0))
			{
				cout << "\t Crypting file " << argv[i+1] << " with key '" << argv[i+3] << "'" << endl << endl;
				LCA2_FILE_CRYPT(argv[i+1],argv[i+2],argv[i+3]);
				i+=3;
			}
			else if((strcmp(argv[i],"-d")==0))
			{
				cout << "\t Decrypting file " << argv[i+1] << " with key '" << argv[i+3] << "'" << endl << endl;
				LCA2_FILE_DECRYPT(argv[i+1],argv[i+2],argv[i+3]);
				i+=3;
			}
			else
			{
				cout << "Error! Type `lca -h` for help!" << endl << endl;
				return 1;
			}
            
        }
    }

	return 0;
}

//
