/************************************
Anton (Liloi) Moskalenko
e-mail: liloi@mail.ru
05.08.06
R:
14.08.06
************************************/

/*

LCA2_FILE_CRYPT
LCA2_FILE_DECRYPT

LCA2_dyn_d
LCA2_dyn_c
LCA2_sta_d
LCA2_sta_c

LCA2_key_sum
LCA2_key_sred
LCA2_cycr

LCA2_FillSta
LCA2_FillDyn

*/

#ifndef LCA2
#define LCA2

#include <lca2const.h>
#include <iostream.h>
#include <fstream.h>

int LCA2_key_sum(char key[]);
void LCA2_FillSta();
void LCA2_FillDyn(char key[]);


unsigned char LCA2_dyn_d(unsigned char d)
{
	return LCA2_DYN_MAS[d];
}



unsigned char LCA2_dyn_c(unsigned char d)
{
	for(int i = 0;i<256;i++)
	{
		if(LCA2_DYN_MAS[i]==d) return i;
	}
}



unsigned char LCA2_sta_d(unsigned char d)
{
	return LCA2_STA_MAS[d];
}



unsigned char LCA2_sta_c(unsigned char d)
{
	for(int i = 0;i<256;i++)
	{
		if(LCA2_STA_MAS[i]==d) return i;
	}
}



bool LCA2_FILE_CRYPT(char *fn, char *ou, char *key)
{

	LCA2_FillSta();
	LCA2_FillDyn(key);
  
	char dat, cr = 17, tmp = 0;
	int i = 0;


    fstream fil;
    fil.open(fn,ios::in);
    
    fstream ini;
    ini.open(ou,ios::out);
    
    if(!fil)
    {
        return false;
    }
	
	ini.write("LCA2",4);
        
    while(!fil.eof())
    {

    fil.read(&dat,1);

	tmp = dat;
	dat = LCA2_dyn_c(dat);
	dat = LCA2_sta_c(dat);
	dat -= cr;

	
	cr += tmp;
	
	
	if(!fil.eof()) ini.write(&dat,1);

    }
    
    fil.close();
    ini.close();
    
	return true;

}



bool LCA2_FILE_DECRYPT(char *fn, char *ou, char *key)
{

	LCA2_FillSta();
	LCA2_FillDyn(key);
  
	char dat, cr = 17, tmp = 0;
	int i = 0;

	
	char linit;

    fstream fil;
    fil.open(fn,ios::in);
    
    fstream ini;
    ini.open(ou,ios::out);
    
    if(!fil)
    {
        return false;
    }
    
	fil.read(&linit,4);    
    
    
    while(!fil.eof())
    {

    fil.read(&dat,1);


	dat += cr;
	dat = LCA2_sta_d(dat);
	dat = LCA2_dyn_d(dat);
	tmp = dat;
	cr += tmp;
	
	
	if(!fil.eof()) ini.write(&dat,1);

    }
    
    fil.close();
    ini.close();
    
	return true;

}



int LCA2_key_sum(char key[])
{
	int res = 0;
	
	for(int i=0;i<strlen(key);i++)
	{
		res+=key[i];
	}
	return res;
}



unsigned char LCA2_key_sred(char key[])
{
	int dat = LCA2_key_sum(key);
	dat /= strlen(key);
	return dat;
}



unsigned char LCA2_cycr(unsigned char d)
{
	unsigned char dat = d >> 1;
	unsigned char mask = 0x80;
		
	if(d&1) dat+=mask;
	
	return dat;
}



void LCA2_FillSta()
{
	for(int i=0;i<256;i++)
	{
		LCA2_STA_MAS[i] = LCA2_cycr(i+17);
	}
}



void LCA2_FillDyn(char key[])
{

	int sum = LCA2_key_sum(key);
	unsigned char sr = LCA2_key_sred(key);
	
	for(int i=0;i<256;i++)
	{
		LCA2_DYN_MAS[i] = LCA2_STA_MAS[i]^(sum+sr);
	}
	
}


#endif

//
